/****************************************************************************
 *
 *            Copyright (c) 2006-2007 by CMX Systems, Inc.
 *
 * This software is copyrighted by and is the sole property of
 * CMX.  All rights, title, ownership, or other interests
 * in the software remain the property of CMX.  This
 * software may only be used in accordance with the corresponding
 * license agreement.  Any unauthorized use, duplication, transmission,
 * distribution, or disclosure of this software is expressly forbidden.
 *
 * This Copyright notice may not be removed or modified without prior
 * written consent of CMX.
 *
 * CMX reserves the right to modify this software without notice.
 *
 * CMX Systems, Inc.
 * 12276 San Jose Blvd. #511
 * Jacksonville, FL 32223
 * USA
 *
 * Tel:  (904) 880-1840
 * Fax:  (904) 880-1632
 * http: www.cmx.com
 * email: cmx@cmx.com
 *
 ***************************************************************************/
#include "usb-drv/usb.h"
#include "target.h"
#include "hid_mouse.h"
#include "hid_kbd.h"
#include "hid_generic.h"
#include "Bootloader.h"
/****************************************************************************
 ************************** Macro definitions *******************************
 ***************************************************************************/
/* none */

/****************************************************************************
 ************************** Function predefinitions. ************************
 ***************************************************************************/
extern asm void start(void);

/****************************************************************************
 ************************** Global variables ********************************
 ***************************************************************************/
/* none */

/****************************************************************************
 ************************** Module variables ********************************
 ***************************************************************************/
/* none */

/****************************************************************************
 ************************** Function definitions ****************************
 ***************************************************************************/



//***********************************************
// User Entry vectors for bootloader

const byte _UserEntry[] @ USER_ENTRY_ADDRESS = {
  0x4E,
  0x71,
  0x4E,
  0xF9           //asm NOP(0x4E71), asm JMP(0x4EF9)           
};

void  (* const _UserEntry2[])()@(USER_ENTRY_ADDRESS+4)=
{
  start,
};



int main()
{
  hcc_u8 tmp;
  dword* VECTOR_RAM;

  // Set the interrupt handlers in the vector table
  VECTOR_RAM = (dword*)((64 + 53) * 4 + MIN_RAM1_ADDRESS); 
  *VECTOR_RAM = (dword) &usb_it_handler;
  
  // Redirect interrupt vectors to RAM
  mcf5xxx_wr_vbr( (dword) MIN_RAM1_ADDRESS);	
  
  hw_init();

  Usb_Vbus_Off();

  /* See in what mode should we run. */
  tmp = (hcc_u8)(SW1_ACTIVE() ? 1 : 0);
  tmp |= (hcc_u8)(SW2_ACTIVE() ? 2 : 0);

  /* Start the right HID application. */
  switch(tmp)
  {
  case 0:
  default:
    usb_cfg_init();
    set_mode(dm_mouse);
    (void)hid_mouse();
    break;
  case 1:
    usb_cfg_init();
    set_mode(dm_kbd);
    hid_kbd();
    break;
  case 2:
    usb_cfg_init();
    set_mode(dm_generic);
    hid_generic();    
    break;
  }
  /* We will never get here. */
  return 0;
}
/****************************** END OF FILE **********************************/
