/* Coldfire C Header File
 * Copyright Freescale Semiconductor Inc
 * All rights reserved.
 *
 * 2008/02/26 Revision: 0.1
 *
 * (c) Copyright UNIS, spol. s r.o. 1997-2008
 * UNIS, spol. s r.o.
 * Jundrovska 33
 * 624 00 Brno
 * Czech Republic
 * http      : www.processorexpert.com
 * mail      : info@processorexpert.com
 */

#ifndef __MCF52259_FEC_H__
#define __MCF52259_FEC_H__


/*********************************************************************
*
* Fast Ethernet Controller (FEC)
*
*********************************************************************/

/* Register read/write macros */
#define MCF_FEC_ECR                          (*(vuint32*)(0x40001000))
#define MCF_FEC_EIR                          (*(vuint32*)(0x40001004))
#define MCF_FEC_EIMR                         (*(vuint32*)(0x40001008))
#define MCF_FEC_IVSR                         (*(vuint32*)(0x4000100C))
#define MCF_FEC_RDAR                         (*(vuint32*)(0x40001010))
#define MCF_FEC_TDAR                         (*(vuint32*)(0x40001014))
#define MCF_FEC_MMFR                         (*(vuint32*)(0x40001040))
#define MCF_FEC_MSCR                         (*(vuint32*)(0x40001044))
#define MCF_FEC_FRBR                         (*(vuint32*)(0x4000108C))
#define MCF_FEC_FRSR                         (*(vuint32*)(0x40001090))
#define MCF_FEC_TFWR                         (*(vuint32*)(0x400010A4))
#define MCF_FEC_TFSR                         (*(vuint32*)(0x400010AC))
#define MCF_FEC_RCR                          (*(vuint32*)(0x40001104))
#define MCF_FEC_MFLR                         (*(vuint32*)(0x40001108))
#define MCF_FEC_TCR                          (*(vuint32*)(0x40001144))
#define MCF_FEC_MALR                         (*(vuint32*)(0x400013C0))
#define MCF_FEC_MAUR                         (*(vuint32*)(0x400013C4))
#define MCF_FEC_HTUR                         (*(vuint32*)(0x400013C8))
#define MCF_FEC_HTLR                         (*(vuint32*)(0x400013CC))
#define MCF_FEC_ERDSR                        (*(vuint32*)(0x400013D0))
#define MCF_FEC_ETDSR                        (*(vuint32*)(0x400013D4))
#define MCF_FEC_EMRBR                        (*(vuint32*)(0x400013D8))


/* Bit definitions and macros for MCF_FEC_ECR */
#define MCF_FEC_ECR_RESET                    (0x1)
#define MCF_FEC_ECR_ETHER_EN                 (0x2)
#define MCF_FEC_ECR_TX_RT                    (0x2000000)

/* Bit definitions and macros for MCF_FEC_EIR */
#define MCF_FEC_EIR_UMINT                    (0x200000)
#define MCF_FEC_EIR_EBERR                    (0x400000)
#define MCF_FEC_EIR_MII                      (0x800000)
#define MCF_FEC_EIR_RXB                      (0x1000000)
#define MCF_FEC_EIR_RXF                      (0x2000000)
#define MCF_FEC_EIR_TXB                      (0x4000000)
#define MCF_FEC_EIR_TXF                      (0x8000000)
#define MCF_FEC_EIR_GRA                      (0x10000000)
#define MCF_FEC_EIR_BABT                     (0x20000000)
#define MCF_FEC_EIR_BABR                     (0x40000000)
#define MCF_FEC_EIR_HBERR                    (0x80000000)
#define MCF_FEC_EIR_CLEAR_ALL                (0xFFFFFFFF)

/* Bit definitions and macros for MCF_FEC_EIMR */
#define MCF_FEC_EIMR_EBERR                   (0x400000)
#define MCF_FEC_EIMR_MII                     (0x800000)
#define MCF_FEC_EIMR_RXB                     (0x1000000)
#define MCF_FEC_EIMR_RXF                     (0x2000000)
#define MCF_FEC_EIMR_TXB                     (0x4000000)
#define MCF_FEC_EIMR_TXF                     (0x8000000)
#define MCF_FEC_EIMR_GRA                     (0x10000000)
#define MCF_FEC_EIMR_BABT                    (0x20000000)
#define MCF_FEC_EIMR_BABR                    (0x40000000)
#define MCF_FEC_EIMR_HBERR                   (0x80000000)
#define MCF_FEC_EIMR_MASK_ALL                (0)
#define MCF_FEC_EIMR_UNMASK_ALL              (0xFFFFFFFF)

/* Bit definitions and macros for MCF_FEC_IVSR */
#define MCF_FEC_IVSR_IVEC(x)                 (((x)&0x3)<<0x2)

/* Bit definitions and macros for MCF_FEC_RDAR */
#define MCF_FEC_RDAR_R_DES_ACTIVE            (0x1000000)

/* Bit definitions and macros for MCF_FEC_TDAR */
#define MCF_FEC_TDAR_X_DES_ACTIVE            (0x1000000)

/* Bit definitions and macros for MCF_FEC_MMFR */
#define MCF_FEC_MMFR_DATA(x)                 (((x)&0xFFFF)<<0)
#define MCF_FEC_MMFR_TA(x)                   (((x)&0x3)<<0x10)
#define MCF_FEC_MMFR_TA_10                   (0x20000)
#define MCF_FEC_MMFR_RA(x)                   (((x)&0x1F)<<0x12)
#define MCF_FEC_MMFR_PA(x)                   (((x)&0x1F)<<0x17)
#define MCF_FEC_MMFR_OP(x)                   (((x)&0x3)<<0x1C)
#define MCF_FEC_MMFR_OP_READ                 (0x20000000)
#define MCF_FEC_MMFR_OP_WRITE                (0x10000000)
#define MCF_FEC_MMFR_ST(x)                   (((x)&0x3)<<0x1E)
#define MCF_FEC_MMFR_ST_01                   (0x40000000)

/* Bit definitions and macros for MCF_FEC_MSCR */
#define MCF_FEC_MSCR_MII_SPEED(x)            (((x)&0x3F)<<0x1)
#define MCF_FEC_MSCR_DIS_PREAMBLE            (0x80)

/* Bit definitions and macros for MCF_FEC_FRBR */
#define MCF_FEC_FRBR_R_BOUND(x)              (((x)&0x1FF)<<0x2)

/* Bit definitions and macros for MCF_FEC_FRSR */
#define MCF_FEC_FRSR_R_FSTART(x)             (((x)&0xFF)<<0x2)

/* Bit definitions and macros for MCF_FEC_TFWR */
#define MCF_FEC_TFWR_X_WMRK(x)               (((x)&0x3)<<0)
#define MCF_FEC_TFWR_X_WMRK_64               (0)
#define MCF_FEC_TFWR_X_WMRK_128              (0x2)
#define MCF_FEC_TFWR_X_WMRK_192              (0x3)

/* Bit definitions and macros for MCF_FEC_TFSR */
#define MCF_FEC_TFSR_X_FSTART(x)             (((x)&0xFF)<<0x2)

/* Bit definitions and macros for MCF_FEC_RCR */
#define MCF_FEC_RCR_LOOP                     (0x1)
#define MCF_FEC_RCR_DRT                      (0x2)
#define MCF_FEC_RCR_MII_MODE                 (0x4)
#define MCF_FEC_RCR_PROM                     (0x8)

/* Bit definitions and macros for MCF_FEC_MFLR */
#define MCF_FEC_MFLR_MAX_FL(x)               (((x)&0x7FF)<<0)
#define MCF_FEC_MFLR_HASH(x)                 (((x)&0x3F)<<0x18)
#define MCF_FEC_MFLR_MULTCAST                (0x40000000)
#define MCF_FEC_MFLR_BRDCAST                 (0x80000000)

/* Bit definitions and macros for MCF_FEC_TCR */
#define MCF_FEC_TCR_GTS                      (0x1)
#define MCF_FEC_TCR_HBC                      (0x2)
#define MCF_FEC_TCR_FDEN                     (0x4)

/* Bit definitions and macros for MCF_FEC_MALR */
#define MCF_FEC_MALR_ADDR_LOW(x)             (((x)&0xFFFFFFFF)<<0)

/* Bit definitions and macros for MCF_FEC_MAUR */
#define MCF_FEC_MAUR_ADDR_HIGH(x)            (((x)&0xFFFF)<<0x10)

/* Bit definitions and macros for MCF_FEC_HTUR */
#define MCF_FEC_HTUR_HASH_HIGH(x)            (((x)&0xFFFFFFFF)<<0)

/* Bit definitions and macros for MCF_FEC_HTLR */
#define MCF_FEC_HTLR_HASH_LOW(x)             (((x)&0xFFFFFFFF)<<0)

/* Bit definitions and macros for MCF_FEC_ERDSR */
#define MCF_FEC_ERDSR_R_DES_START(x)         (((x)&0x3FFFFFFF)<<0x2)

/* Bit definitions and macros for MCF_FEC_ETDSR */
#define MCF_FEC_ETDSR_X_DES_START(x)         (((x)&0x3FFFFFFF)<<0x2)

/* Bit definitions and macros for MCF_FEC_EMRBR */
#define MCF_FEC_EMRBR_R_BUF_SIZE(x)          (((x)&0x7F)<<0x4)


#endif /* __MCF52259_FEC_H__ */
